//
// SnapshotsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class SnapshotsAPI {
    /**
     Get snapshot of requested camera

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraSnapshot(cameraId: UUID, completion: @escaping ((_ data: Void?,_ error: Error?) -> Void)) {
        getCameraSnapshotWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            if error == nil {
                completion((), error)
            } else {
                completion(nil, error)
            }
        }
    }


    /**
     Get snapshot of requested camera
     - GET /api/v1/camerasnapshots/{camera_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<Void> 
     */
    open class func getCameraSnapshotWithRequestBuilder(cameraId: UUID) -> RequestBuilder<Void> {
        var path = "/api/v1/camerasnapshots/{camera_id}"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get snapshot of requested event

     - parameter eventId: (path)  
     - parameter eventType: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventSnapshot(eventId: UUID, eventType: EventTypeEnum, completion: @escaping ((_ data: Void?,_ error: Error?) -> Void)) {
        getEventSnapshotWithRequestBuilder(eventId: eventId, eventType: eventType).execute { (response, error) -> Void in
            if error == nil {
                completion((), error)
            } else {
                completion(nil, error)
            }
        }
    }


    /**
     Get snapshot of requested event
     - GET /api/v1/snapshots/{event_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example=""}]
     - parameter eventId: (path)  
     - parameter eventType: (query)  

     - returns: RequestBuilder<Void> 
     */
    open class func getEventSnapshotWithRequestBuilder(eventId: UUID, eventType: EventTypeEnum) -> RequestBuilder<Void> {
        var path = "/api/v1/snapshots/{event_id}"
        let eventIdPreEscape = "\(eventId)"
        let eventIdPostEscape = eventIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{event_id}", with: eventIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "event_type": eventType
        ])


        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
